
#include <stdio.h>
#include <stdlib.h>

#define MAX_LOCATIONS 4000
#define MAX_STACK     4000

int location[MAX_LOCATIONS];
int expression_stack[MAX_STACK];

int stackptr = 0;
int util0;

void runtime_error(const char *msg)
{
  fprintf(stderr,msg);
  exit(1);
}

void mul()
{
  if(stackptr > 1)
    expression_stack[stackptr - 2] = expression_stack[stackptr - 2]
      * expression_stack[stackptr - 1];
  else
    runtime_error("Stack underflow");

  stackptr--;
}

void div()
{
  if(expression_stack[stackptr - 1] == 0)
    runtime_error("Division by zero");

  if(stackptr > 1)
    expression_stack[stackptr - 2] = expression_stack[stackptr - 2]
      / expression_stack[stackptr - 1];

  else
    runtime_error("Stack underflow");

  stackptr--;
}

void add()
{
  if(stackptr > 1)
    expression_stack[stackptr - 2] = expression_stack[stackptr - 2]
      + expression_stack[stackptr - 1];
  else
    runtime_error("Stack underflow");

  stackptr--;
}

void sub()
{
  if(stackptr > 1)
    expression_stack[stackptr - 2] = expression_stack[stackptr - 2]
      - expression_stack[stackptr - 1];
  else
    runtime_error("Stack underflow");

  stackptr--;
}

int main()
{

scanf("%d",&util0);
location[0] = util0;
scanf("%d",&util0);
location[1] = util0;
expression_stack[stackptr] = location[0];
stackptr++;
expression_stack[stackptr] = location[1];
stackptr++;
add();
location[2] = expression_stack[0];
stackptr = 0;
expression_stack[stackptr] = location[0];
stackptr++;
expression_stack[stackptr] = location[1];
stackptr++;
mul();
location[3] = expression_stack[0];
stackptr = 0;
expression_stack[stackptr] = location[2];
stackptr++;
printf("%d\n",expression_stack[0]);
stackptr = 0;
expression_stack[stackptr] = location[2];
stackptr++;
expression_stack[stackptr] = 2;
stackptr++;
div();
printf("%d\n",expression_stack[0]);
stackptr = 0;
}
