#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "lexer-v2-1.h"

/*

  Use a simple BST
  
 */



static int location = 0;
struct symbol
{
  struct symbol *left;
  struct symbol *right;
  char *symbol;
  int location;
};

typedef struct symbol *symbol;

static symbol symbol_table = NULL;

static int bst_add(char *s, symbol symbol)
{
  if(symbol == NULL)
    {
      struct symbol *new_symbol = malloc(sizeof(struct symbol));
      if(!new_symbol)
	fail("symbol_table.c bst_add(): malloc fails");
      new_symbol->symbol = strdup(s);
      new_symbol->location = location++;
      new_symbol->left = NULL;
      new_symbol->right = NULL;
      symbol_table = new_symbol;
      return(new_symbol->location);
    }

  int dir = strcmp(s,symbol->symbol);
  if(dir == 0)
    {
      fprintf(stderr,"Symbol %s redefined!\n",s);
      return(symbol->location);
    }
  else if(dir < 0)
    {
      if(symbol->left)
	{
	  return(bst_add(s,symbol->left));
	}
      else
	{
	  struct symbol *new_symbol = malloc(sizeof(struct symbol));
	  if(!new_symbol)
	    fail("symbol_table.c bst_add(): malloc fails");
	  new_symbol->symbol = strdup(s);
	  new_symbol->location = location++;
	  new_symbol->left = NULL;
	  new_symbol->right = NULL;
	  symbol->left = new_symbol;
	  return(new_symbol->location);
	}
    }
  else if(dir > 0)
    {
      if(symbol->right)
	{
	  return(bst_add(s,symbol->right));
	}
      else
	{
	  struct symbol *new_symbol = malloc(sizeof(struct symbol));
	  if(!new_symbol)
	    fail("symbol_table.c bst_add(): malloc fails");
	  new_symbol->symbol = strdup(s);
	  new_symbol->location = location++;
	  new_symbol->left = NULL;
	  new_symbol->right = NULL;
	  symbol->right = new_symbol;
	  return(new_symbol->location);
	}
    }
  fail("Impossible return path in bst_add()");
  __builtin_unreachable();
}

static int bst_lookup(char *s, symbol symbol)
{
  if( (symbol_table == NULL) || (symbol == NULL) )
    return -1;
  int dir = strcmp(s,symbol->symbol);
  if(dir == 0)
    return(symbol->location);
  if(dir < 0)
    return(bst_lookup(s,symbol->left));
  if(dir > 0)
    return(bst_lookup(s,symbol->right));
  fail("Impossible location");
  __builtin_unreachable();
}

// returns location
int symbol_table_add(char *label)
{
  // returns index in storage table associated with this label
  return(bst_add(label,symbol_table));

}

// returns location, -1 if not
int symbol_table_lookup(char *label)
{
   return(bst_lookup(label,symbol_table));
}
